#!/usr/bin/python3
# -*- coding: Utf-8 -*

"""
Jeu Donkey Kong Labyrinthe
Jeu dans lequel on doit déplacer DK jusqu'aux bananes à travers un labyrinthe.

Script Python
Fichiers : dklabyrinthe.py, classes.py, constantes.py, n1, n2 + images
"""

import pygame
import classes as cl
import constantes as cst

pygame.init()

#Ouverture de la fenêtre Pygame (carré : largeur = hauteur)
fenetre = pygame.display.set_mode((cst.cote_fenetre, cst.cote_fenetre))
#Icone
icone = pygame.image.load(cst.image_icone)
pygame.display.set_icon(icone)
#Titre
pygame.display.set_caption(cst.titre_fenetre)


#BOUCLE PRINCIPALE
continuer = True
while continuer:	
	#Chargement et affichage de l'écran d'accueil
	accueil = pygame.image.load(cst.image_accueil).convert()
	fenetre.blit(accueil, (0,0))

	#Rafraichissement
	pygame.display.flip()

	#On remet ces variables à 1 à chaque tour de boucle
	continuer_jeu = True
	continuer_accueil = True

	#BOUCLE D'ACCUEIL
	while continuer_accueil:
	
		#Limitation de vitesse de la boucle
		pygame.time.Clock().tick(30)
	
		for event in pygame.event.get():
		
			#Si l'utilisateur quitte, on met les variables 
			#de boucle à 0 pour n'en parcourir aucune et fermer
			if event.type == pygame.QUIT or event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
				continuer_accueil = False
				continuer_jeu =False
				continuer = False
				#Variable de choix du niveau
				choix = 0
				
			elif event.type == pygame.KEYDOWN:				
				#Lancement du niveau 1
				if event.key == pygame.K_F1:
					continuer_accueil = False	#On quitte l'accueil
					choix = 'n1'		#On définit le niveau à charger
				#Lancement du niveau 2
				elif event.key == pygame.K_F2:
					continuer_accueil = False
					choix = 'n2'
			
		

	#on vérifie que le joueur a bien fait un choix de niveau
	#pour ne pas charger s'il quitte
	if choix != 0:
		#Chargement du fond
		fond = pygame.image.load(cst.image_fond).convert()

		#Génération d'un niveau à partir d'un fichier
		niveau = cl.Niveau(choix)
		niveau.generer()
		niveau.afficher(fenetre)

		#Création de Donkey Kong
		dk = cl.Perso("images/dk_droite.png", "images/dk_gauche.png", 
		"images/dk_haut.png", "images/dk_bas.png", niveau)

				
	#BOUCLE DE JEU
	while continuer_jeu:
	
		#Limitation de vitesse de la boucle
		pygame.time.Clock().tick(30)
	
		for event in pygame.event.get():
		
			#Si l'utilisateur quitte, on met la variable qui continue le jeu
			#ET la variable générale à 0 pour fermer la fenêtre
			if event.type == pygame.QUIT:
				continuer_jeu = 0
				continuer = 0
		
			elif event.type == pygame.KEYDOWN:
				#Si l'utilisateur presse Echap ici, on revient seulement au menu
				if event.key == pygame.K_ESCAPE:
					continuer_jeu = 0
					
				#Touches de déplacement de Donkey Kong
				elif event.key == pygame.K_RIGHT:
					dk.deplacer('droite')
				elif event.key == pygame.K_LEFT:
					dk.deplacer('gauche')
				elif event.key == pygame.K_UP:
					dk.deplacer('haut')
				elif event.key == pygame.K_DOWN:
					dk.deplacer('bas')			
			
		#Affichages aux nouvelles positions
		fenetre.blit(fond, (0,0))
		niveau.afficher(fenetre)
		fenetre.blit(dk.direction, (dk.x, dk.y)) #dk.direction = l'image dans la bonne direction
		pygame.display.flip()

		#Victoire -> Retour à l'accueil
		if niveau.structure[dk.case_y][dk.case_x] == 'a':
			continuer_jeu = 0

pygame.quit()